package
{	
	import com.greensock.TweenLite;
	import com.greensock.TweenMax;
	import com.greensock.data.TweenLiteVars;
	import com.greensock.plugins.HexColorsPlugin;
	import com.greensock.plugins.TweenPlugin;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.ui.Mouse;
	
	import mx.utils.StringUtil;
	
	import org.flixel.*;
	
	public class GameState extends FlxState
	{
		[Embed(source = "data/bg.png")] public static var ImgBG:Class;	
		[Embed(source = "data/bg2.png")] public static var ImgBG2:Class;		
		[Embed(source = "data/button.png")] public static var ImgPiece:Class;		
		[Embed(source = "data/blannkbutton.png")] public static var ImgBlankPiece:Class;		
		[Embed(source = "data/selector.png")] public static var ImgSelector:Class;		
		[Embed(source = "data/cursor.png")] public static var ImgCursor:Class;		
		[Embed(source = "data/blip.mp3")] public var SndPaletteAdd:Class;	
		[Embed(source = "data/blip.mp3")] public var SndBlip:Class;
		[Embed(source = "data/blip.mp3")] public static var SndEndStage:Class;	
		//[Embed(source = "data/yum4.mp3")] public static var Snd1:Class;
		//[Embed(source = "data/level1.txt", mimeType="application/octet-stream")] public static var Level1:Class;
		
		private static var bitmapkeys:Object={};
		
		private var colors:Vector.<uint>;
		private var oldgrid:Vector.<Vector.<int>>;
		private var grid:Vector.<Vector.<int>>;
		private var pieces:Vector.<Vector.<FlxSprite>>;
		
		private static var firstlevel:Boolean=true;
		private var selector:FlxSprite;
		
		private var newcolorkeys:Array;
		private var grid2:Vector.<Vector.<int>>;
		private var pieces2:Vector.<Vector.<FlxSprite>>;
		private var patterns:Vector.<FlxSprite>;
		
		public static var oldcolorcount:int=4;
		public static var colorcount:int=4;
		private static var colorkeys:Array=["0000","0011","0120","0123"];
		private const patternsize:int=126;
		
		private const leftoffset:int=44;
		
		private const topoffset:int=58;
		private const piecesize:int=62;
		
		private static var oldpalette:Array = null;
		private var palette:Vector.<Vector.<int>>;
		
		private var _bg:FlxSprite;
		private var _bg2:FlxSprite;
		
		private const healthoffsetx:int=333+16;
		private const healthoffsety:int=54;
		private const healthcount:int=8;
		private const healthborder:int=4;
		private const healthbarheight:int=596;
		private const healthblipheight:int = 60;//(healthbarheight+healthborder)/(healthcount+1);
		
		private var blips:Vector.<FlxSprite>;
		private var _health:int;
				
		private var removing:Boolean=false;
		
		private function backupgrid():void
		{
			oldgrid = new Vector.<Vector.<int>>();
			for (var i:int=0;i<grid.length;i++)
			{
				var column:Vector.<int> = new Vector.<int>();
				for (var j:int=0;j<grid[i].length;j++)
				{
					column.push(grid[i][j]);
				}
				oldgrid.push(column);
			}
		}
		
		public function drawblips():void
		{
			for (var i:int=0;i<blips.length;i++)
			{
				if (blips[i].visible==true && i>=_health)
				{
					var s:FlxSprite = new FlxSprite(blips[i].x,blips[i].y);
					s.pixels=blips[i].pixels;
					add(s);
					TweenLite.to(s,0.5,{alpha:0,scalarscale:4,onComplete:function():void{remove(s);}});
				}
				blips[i].visible=i<_health;
			}
		}
		
		override public function create():void
		{						
			super.create();
			newcolorkeys = [];
			
			for (i=0;i<colorkeys.length;i++)
			{
				if (bitmapkeys[key]==undefined)
				{
					var key:String = colorkeys[i];
					var bm:Bitmap = new ImgPiece();
					drawcodeonbitmap(key,bm.bitmapData);
					bitmapkeys[key]=bm.bitmapData;
				}				
			}
			
			_health=healthcount;
			palette = new Vector.<Vector.<int>>();
			
			_bg = new FlxSprite(0,0,ImgBG);
			add(_bg);
			
			blips = new Vector.<FlxSprite>();
			for (i=0;i<healthcount;i++)
			{
				var s:FlxSprite = new FlxSprite(healthoffsetx,healthoffsety+(healthblipheight+healthborder)*i,null);
				s.makeGraphic(22,healthblipheight,1%2==0?0xff000000:0xffffffff,false,i%2==0?"WBLIP":"BBLIP");
				add(s);
				blips.push(s);
			}
				
			drawblips();
			
			colors = new Vector.<uint>();
			var curh:Number = Math.random()*360;
			for (var i:int=0;i<colorcount;i++)
			{
				//* @param	h Hue (0-360)
				//* @param	s Saturation(0-1)
				//* @param	l Luminance(0-1)
				var hsl:HSL = new HSL(curh,0.75,0.5);
				colors.push(hsl.toRGB().Hex);
				curh=(curh+360/(colorcount+1))%360;
			}
			
			selector = new FlxSprite(0,0,ImgSelector);
			selector.visible=false;
			add(selector);
			
			var j:int;
			grid = new Vector.<Vector.<int>>();
			pieces = new Vector.<Vector.<FlxSprite>>();
			for (i=0;i<4;i++)
			{
				var row:Vector.<int> = new Vector.<int>();
				var sprow:Vector.<FlxSprite> = new Vector.<FlxSprite>();
				for (j=0;j<8;j++)
				{
					var colindex:int=(int)(Math.random()*colorcount);
					var col:uint = colors[colindex];
					row.push(colindex);
					var spr:FlxSprite = new FlxSprite(leftoffset+i*piecesize,topoffset+j*piecesize,ImgPiece);
					spr.color=col;
					
					add(spr);
					
					sprow.push(spr);					
				}
				grid.push(row);
				pieces.push(sprow);
			}
			
			grid2 = new Vector.<Vector.<int>>();
			pieces2 = new Vector.<Vector.<FlxSprite>>();
			for (i=0;i<4;i++)
			{
				var row2:Vector.<int> = new Vector.<int>();
				var sprow2:Vector.<FlxSprite> = new Vector.<FlxSprite>();
				for (j=0;j<8;j++)
				{
					var col2:int = -1;
					var spr2:FlxSprite = new FlxSprite(376+20+i*62+((int)(i/2))*4,61+j*62+((int)(j/2))*4,ImgBlankPiece);
					spr2.resetHelpers();
					spr2.color=col2;
					spr2.alpha=0;
					spr.color=col;
					row2.push(-1);
					add(spr2);					
					sprow2.push(spr2);					
				}
				grid2.push(row2);
				pieces2.push(sprow2);
			}
			
			patterns = new Vector.<FlxSprite>();
			for (i=0;i<8;i++)
			{
				var spr3:FlxSprite = new FlxSprite(394+130*(i%2),59+130*((int)(i/2)),null);
				spr3.makeGraphic(126,126,0x00000000,false);
				spr3.visible=false;
				patterns.push(spr3);				
				add(spr3);
			}
			populatepalette();
			setcolors();
						
			_bg2 = new FlxSprite(0,0,ImgBG2);
			add(_bg2);
			
			if (oldpalette!=null)
			{
				removing=true;
				for (i=0;i<pieces.length;i++)
				{
					for (j=0;j<pieces[i].length;j++)
					{
						var curspr:FlxSprite = pieces[i][j];					
						var tx:Number=curspr.x;
						var ty:Number=curspr.y;
						curspr.x=394+128*((int)(grid[i][j]%2))+33;
						curspr.y=59+128*((int)(grid[i][j]/2))+33;
						curspr.scalarscale=2;
						var oldcol:uint=curspr.color;
						curspr.color=0xffffff;
						
						TweenLite.to(
							curspr, 
							1, 
							new TweenLiteVars(
								{
									x:tx,
									y:ty,
									scalarscale:1
								}
							)
							.hexColors({color:oldcol})
							.onComplete(function():void{removing=false;})
							);
					}
				}
			}
			
			var r:int=Math.random()*5;
			if (colorcount==1)
			{
				fading=true;
				FlxG.fade(0xffffff,2,onFade,true);
			}
			
			if (firstlevel)
			{
				firstlevel=false;
				FlxG.flash(0);
			}
			else
			{
				FlxG.play(SndEndStage);
			}
		}
		
		private function onFade():void
		{
			TweenMax.killAll(false); 
			FlxG.switchState(new EndState());
		}
		
		private function processnums(arr:Array):Array
		{
			var result:Array = [];
			var key:Array = [];
			
			for (var i:int=0;i<arr.length;i++)
			{
				var index:int = key.indexOf(arr[i]);
				if (index==-1)
				{
					key.push(arr[i]);
					index=key.length-1;
				}				
				result.push(index);
			}
			return result;
		}
		
		private static var points:Array = [[10+0.5,10+0.5],[48+0.5,10+0.5],[10+0.5,48+0.5],[48+0.5,48+0.5]];
		private static var points2:Array = [[1*126/4,1*126/4],[3*126/4,1*126/4],[1*126/4,3*126/4],[3*126/4,3*126/4]];
		private static var points3:Array = [[3*1*126/4,3*1*126/4],[3*3*126/4,3*1*126/4],[3*1*126/4,3*3*126/4],[3*3*126/4,3*3*126/4]];
		
		public static function drawcodeonbitmap(s:String, target:BitmapData, large:Boolean=false,reallylarge:Boolean=false,drawcolor:uint=0x00000000):void
		{
			
			if (large)
			{
				target.fillRect(target.rect,0x00000000);
			}
			
			for (i=0;i<points.length;i++)
			{				
				//var drawShape:Sprite = new Sprite;	
				//drawShape.graphics.drawRect();				
				var sprt:Sprite = new Sprite();	
				if (large==false)
				{
					//sprt.graphics.lineStyle(7, 0x000000);						
					sprt.graphics.beginFill(drawcolor);
					sprt.graphics.drawCircle(points[i][0],points[i][1],4);		
					sprt.graphics.endFill();	
				}
				else if (reallylarge)
				{
					//sprt.graphics.lineStyle(10, 0x000000);							
					sprt.graphics.beginFill(drawcolor);
					sprt.graphics.drawCircle(points3[i][0],points3[i][1],14);			
					sprt.graphics.endFill();					
				}
				else
				{
					//sprt.graphics.lineStyle(10, 0x000000);							
					sprt.graphics.beginFill(drawcolor);
					sprt.graphics.drawCircle(points2[i][0],points2[i][1],7);			
					sprt.graphics.endFill();
				}
				
				target.draw(sprt, new Matrix());	
			}
			
			for (var i:int=0;i<s.length;i++)
			{
				for (var j:int=0;j<s.length;j++)
				{					
					if (i==j)
						continue;
					
					if (s.charAt(i)==s.charAt(j))
					{
						var drawShape:Sprite = new Sprite;	
						if (large==false)
						{
							drawShape.graphics.lineStyle(7, drawcolor);
							
							drawShape.graphics.moveTo(points[i][0],points[i][1]);	
							drawShape.graphics.lineTo(points[j][0],points[j][1]);							
						}
						else if (reallylarge)
						{
							drawShape.graphics.lineStyle(14, drawcolor);
							
							drawShape.graphics.moveTo(points3[i][0],points3[i][1]);	
							drawShape.graphics.lineTo(points3[j][0],points3[j][1]);				
						}
						else
						{
							drawShape.graphics.lineStyle(10, drawcolor);	
							
							drawShape.graphics.moveTo(points2[i][0],points2[i][1]);	
							drawShape.graphics.lineTo(points2[j][0],points2[j][1]);																			
						}
						
						target.draw(drawShape, new Matrix());
					}
				}
			}
		}
		
		private function addpalette(px:int,py:int):int
		{
			var nums:Array = [grid[px+0][py+0],grid[px+1][py+0],grid[px+0][py+1],grid[px+1][py+1]];
			nums = processnums(nums);
			var blank:Boolean=true;
			for (var i:int=0;i<nums.length;i++)
			{
				if (nums[i]>=0)
				{
					blank=false;
					break;
				}
			}
			
			if (blank==true)
			{
				return -1;
			}
			
			for (i=0;i<palette.length;i++)
			{
				var identical:Boolean=true;
				for (var j:int=0;j<palette[i].length;j++)
				{
					if (nums[j]!=palette[i][j])
					{
						identical=false;
						break;
					}
				}
				if (identical)
				{
					return i;
				}
			}

			newcolorkeys.push( nums[0].toString()+nums[1].toString()+nums[2].toString()+nums[3].toString() );
			var newpalette:Vector.<int> = new Vector.<int>();
			newpalette.push(nums[0]);
			newpalette.push(nums[1]);
			newpalette.push(nums[2]);
			newpalette.push(nums[3]);
			palette.push(newpalette);
			
			
		 	drawcodeonbitmap(newcolorkeys[newcolorkeys.length-1], patterns[palette.length-1]._pixels,true)
			patterns[palette.length-1].resetHelpers();
			patterns[palette.length-1].visible=true;
			
			populatepalette();
			return palette.length-1;
			//var newpalette:Vector<int>;
		}
		
		private function populatepalette():void
		{
			for (var i:int=0;i<4;i++)
			{
				for (var j:int=0;j<8;j++)
				{
					grid2[i][j]=-1;
				}
			}
			
			for (i=0;i<palette.length;i++)
			{
				var px:int=i % 2;
				var py:int=i/2;
				grid2[2*px+0][2*py+0]=palette[i][0];
				grid2[2*px+1][2*py+0]=palette[i][1];
				grid2[2*px+0][2*py+1]=palette[i][2];
				grid2[2*px+1][2*py+1]=palette[i][3];
			}
		}
		
		private function setcolors():void
		{
			for (var i:int=0;i<4;i++)
			{
				for (var j:int=0;j<8;j++)
				{
					if (grid[i][j]>=0)
					{
						pieces[i][j].alpha=1;
						pieces[i][j].color=colors[grid[i][j]];
						if (bitmapkeys[colorkeys[grid[i][j]]]==undefined)
						{							
							var key:String = colorkeys[grid[i][j]];
							var bm:Bitmap = new ImgPiece();
							drawcodeonbitmap(key,bm.bitmapData);
							bitmapkeys[key]=bm.bitmapData;
						}
						var bmk:BitmapData = bitmapkeys[colorkeys[grid[i][j]]];
						pieces[i][j]._pixels = bmk;
						pieces[i][j].resetHelpers();
					}
					else
					{						
						pieces[i][j].alpha=0;
					}
				}
			}
			
			for (i=0;i<4;i++)
			{
				for (j=0;j<8;j++)
				{
					if (grid2[i][j]>=0)
					{
						pieces2[i][j].alpha=1;
						//pieces2[i][j].color=colors[grid2[i][j]];
					}
					else
					{						
						pieces2[i][j].alpha=0;
					}
				}
			}
		}
		
		private function empty():Boolean
		{
			for (var i:int=0;i<4;i++)
			{
				for (var j:int=0;j<8;j++)
				{
					if (grid[i][j]>=0)
						return false;
				}
			}
			return true;
		}
		
		public function pushdown():void
		{
			var changed:Boolean=true;
			while(changed)
			{
				changed=false;
				for (var i:int=0;i<4;i++)
				{
					for (var j:int=6;j>=0;j--)
					{
						if (grid[i][j+1]==-1 && grid[i][j]!=-1)
						{
							grid[i][j+1] = grid[i][j];
							grid[i][j]=-1;
							changed=true;
							break;
						}
					}
				}
			}
			
			changed=true;
			while (changed)
			{
				changed=false;
				for (i=1;i<4;i++)
				{
					if (blankcol(i-1) && !(blankcol(i)))
					{
						changed=true;	
						for (j=0;j<8;j++)
						{
							grid[i-1][j]=grid[i][j];
							grid[i][j]=-1;
						}
					}
				}
			}
		}
		
		private var fading:Boolean=false;
		
		private function blankrow(r:int):Boolean
		{
			for (var i:int=0;i<4;i++)
			{
				if (grid[i][r]>=0)
					return false;
			}
			return true;
		}
		
		private function blankcol(c:int):Boolean
		{
			for (var j:int=0;j<8;j++)
			{
				if (grid[c][j]>=0)
					return false;
			}
			return true;			
		}
		public function fillblanks():void
		{
			//fill blanks in top row, push down, repeat
			var modified:Boolean=true;
			while(modified)
			{
				modified=false;
				for (var i:int=0;i<4;i++)
				{
					if (grid[i][0]==-1)
					{						
						var colindex:int=(int)(Math.random()*colorcount);
						grid[i][0]=colindex;
						modified=true;
					}
				}
				if (modified)
				{
					pushdown();
				}
			}
		}
		override public function update():void
		{
	 
			
			for (i=0;i<pieces.length;i++)
			{
				for (j=0;j<pieces[i].length;j++)
				{
					pieces[i][j].alpha=1;
				}
			}
			
			
			if (FlxG.mouse.y<topoffset-2 || FlxG.mouse.x<leftoffset-2 || FlxG.mouse.x>leftoffset+4*piecesize+2 || FlxG.mouse.y>topoffset+8*piecesize+2)
			{
				selector.visible=false;
			}
			else
			{
				
				var mindist:int = 10000000;
				var mx:int=FlxG.mouse.x;
				var my:int=FlxG.mouse.y;
				var minx:int=0;
				var miny:int=0;
				
				for (var i:int=0;i<3;i++)
				{
					for (var j:int=0;j<7;j++)
					{
						var cx:int=leftoffset+(i+1)*piecesize;
						var cy:int=topoffset+(j+1)*piecesize;
						var dist:int = (mx-cx)*(mx-cx)+(my-cy)*(my-cy);
						if (dist<mindist)
						{
							mindist=dist;
							minx=i;
							miny=j;
						}
					}
				}	
				
				pieces[minx][miny].alpha=0.5;
				pieces[minx+1][miny].alpha=0.5;
				pieces[minx][miny+1].alpha=0.5;
				pieces[minx+1][miny+1].alpha=0.5;					
			}
			
			if (removing==true)
			{
				return;
			}
			
			
			if (FlxG.mouse.y<topoffset-2 || FlxG.mouse.x<leftoffset-2 || FlxG.mouse.x>leftoffset+4*piecesize+2 || FlxG.mouse.y>topoffset+8*piecesize+2)
			{
				
			}
			else
			{			
				
				selector.visible=true;
				selector.x=leftoffset-2+minx*piecesize;
				selector.y=topoffset-2+miny*piecesize;
				
				
				if (FlxG.mouse.justPressed())
				{
					removing=true;
					selector.visible=false;
					var palpos:int = addpalette(minx,miny);					
					grid[minx][miny]=-1;
					grid[minx+1][miny]=-1;
					grid[minx][miny+1]=-1;
					grid[minx+1][miny+1]=-1;
					backupgrid();
					_health--;
					drawblips();		
					
					pushdown();
					fillblanks();	
					
					populatepalette();	
					setcolors();
										
					if (_health==0 || palette.length>8)
					{		
						oldcolorcount=colorcount;
						colorcount=palette.length;
						makeoldpalette();
						colorkeys=newcolorkeys;
						TweenMax.killAll(false); 
						FlxG.switchState(new GameState());
					}
					else
					{
						displacegrid(minx,miny);
						if (removing)
						{							
							FlxG.play(SndPaletteAdd);
						}
						else
						{
							FlxG.play(SndBlip);
						}
						//removing=false;
					}	
					
					
					/*
					if (palpos>=0)
					{
						var tx:Number=patterns[palpos].x;
						var ty:Number=patterns[palpos].y;
						var fx:Number=pieces[minx][miny].x;
						var fy:Number=pieces[minx][miny].y+120;
						
						var s:FlxSprite = new FlxSprite(fx,fy);
						s.pixels=patterns[palpos].pixels;
						add(s);
						
						
						TweenLite.to(s,0.2,{x:tx,y:ty,onComplete:function():void{remove(s);s.kill();}});
					}*/
					
				}
			}
			
			super.update();
		}		
		
		private function makeoldpalette():void
		{
			oldpalette = [];
			for (var i:int=0;i<palette.length && i<8 ;i++)
			{
				var s:String = "";
				for (var j:int=0;j<palette[i].length;j++)
				{
					s+=palette[i][j];
				}
				oldpalette.push(s);
			}
		}
		
		private function displacegrid(px:int,py:int):void
		{
			for (var i:int=px;i<px+2;i++)
			{
				for (var j:int=py+1;j>=0;j--)
				{
					pieces[i][j].y-=2*piecesize;
					var myTween:TweenLite = new TweenLite(pieces[i][j], 0.5, {y:pieces[i][j].y+2*piecesize,onComplete:function():void{removing=false;}});
				}
			}
		}
		
	}
}